<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <title>Selecionar Elementos #04</title>
  <link rel="stylesheet" href="css/estilo.css">
</head>

<body class="conteudo exercicio">
  <div>
    <p>Início</p>
  </div>
  <div>
    <ul>
      <li>Pedro</li>
      <li>Ana</li>
      <li>Bia</li>
    </ul>
  </div>
  <div>
    <p>Fim</p>
  </div>
  <script>
    function log() {
      console.log(this)
    }

    HTMLCollection.prototype.log = log
    HTMLElement.prototype.log = log
    NodeList.prototype.log = log
    Node.prototype.log = log

    const lista = document.querySelector('div ul')// pega os ul's filhos de uma div
    lista.parentNode.log()// pega o pai  do elemento
    lista.childNodes.log()// pega o filho e considera filho os espaços em branco no html
    
    const primeiro = lista.firstChild//pega o primeiro filho
    primeiro.log()
    primeiro.nextSibling.log()//pega o próximo irmão do elemento

    const ultimo = lista.lastChild//pega o ultimo filho
    ultimo.log()
    ultimo.previousSibling.log()//pega o irmão anterior

    // Preferência nesse

    lista.children.log()// pega somente as tags filhas
    lista.firstElementChild.log()
    lista.lastElementChild.log()
    lista.parentNode.previousElementSibling.log()
    lista.parentNode.nextElementSibling.log()

    document.querySelectorAll('div ul li').log()
  </script>
</body>

</html>